/*
 * Soubor:  easystack.c
 * Datum:   17.03.2011 21:34
 * Autor:   Marek Nožka, nozka <@t> spseol <d.t> cz
 * Licence: GNU/GPL 
 * Úloha: jednoduchá implementace zásobníku pomocí pole
 */

// velikost zásobníku
#define STACKC 128
/***********************************
 *   Hlavičkové soubory
 ***********************************/
#include "easystack.h"
#include <stdio.h>
#include <string.h>

/*********************************** 
 *  Globální proměnné a datové struktury
 ***********************************/
static double stack[STACKC];
static int stackc = 0;


/*********************************** 
 *  Implementace funkcí
 ***********************************/

/* Funkce ukládá číslo do zásobníku,
 * vrací aktuální pozici nebo -1 při přetečení. 
 */
int push(double number)         //%.h   
{
    if (stackc < STACKC) {
        stack[stackc] = number;
        return ++stackc;
    } else
        return -1;
}

/* Funkce vrací číslo, které vyzvedne ze zásobníku.
 * V případě prázdného zásobníku vrátí NAN. */
double pop()                    //%.h   
{
    if (stackc > 0)
        return stack[--stackc];
    else
        return NAN;
}

/* Funkce vrací počet prvků v zásobníku */
int gettstackc(void)            //%.h
{
    return stackc;
}

/* Funkce do řetězce s vytiskne obsah zásobníku */
void spstack(char s[])          //%.h
{
    char bagr[STACKC * 10];

    strcpy(s, "[");
    for (int i = 0; i < stackc; i++) {
        sprintf(bagr, " %g", stack[i]);
        strcat(s, bagr);
    }
    strcat(s, " ]");
}

/* Vymaže celý zásobník */
void stackclear(void) //%.h
{
    stackc = 0;
}

/*
int main()
{
    char s[MSGLEN];

    printf("   %d\n", push(8));
    printf("   %d\n", push(12));
    printf("   %d\n", push(13));
    printf("   %d\n", push(20));

    printf("     %d\n", gettstackc());

    spstack(s);
    printf("#### %s\n", s);

    printf("%g\n", pop());
    printf("%g\n", pop());
    printf("     %d\n", gettstackc());
    printf("%g\n", pop());
    printf("%g\n", pop());
    printf("%g\n", pop());

    stackclear();
}
*/
